/**
 * Title: Expert 07 - Main class for testing access types from different packages
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.test ;

import adriani.tutorial.expert.* ;

public class Expert07 extends Expert04 {

	// Overriding fields inherited from the Expert04 class
	public String[] headings = {"Child (same package)", "Not Child (same package)"} ;	// mind identation

	// Main method
	public static void main(String arg[]) throws Exception {

		Expert07 application = new Expert07() ;
		application.setState() ;

		if (arg.length > 0) {
			if (arg[0].equals("f")) application.fieldsTable() ;
			if (arg[0].equals("m")) application.methodsTable() ;
		}
	}

	// Override of the parent method
	public void setState() {

		parent 	= new Expert05() ;
		child  	= (Expert06) new Expert08() ;
	}

	// Override of the parent method
	public boolean[] testParentMethods() {

		parent.printState() ;				// access public method ?
		//int[] foo = parent.getState() ;	// access protected method ?
		//parent.setState(1,2,3,4) ;		// access package method ?
		//parent.bundle() ;					// access private method ?

		boolean[] result = {true, false, false, false} ;
		return result ;
	}

	// Override of the parent method
	public boolean[] testParentFields() {

		int foo1= parent.publicInt ;		// access public field ?
		//int foo2= parent.protectedInt ;	// access protected field ?
		//int foo3= parent.packageInt ;		// access package field ?
		//int foo4= parent.privateInt ;		// access private field ?

		boolean[] result = {true, false, false, false} ;
		return result ;
	}

} // End of class